
----------------------------------------------------------------------------------------------------------
-- Special controls and custom datarefs for N1101_Ramier by Restauravia.
----------------------------------------------------------------------------------------------------------

----------------------------------- LOCATE AND/OR CREATE DATAREFS AND COMMANDS -----------------------------------
----INIT----
startup_running = find_dataref("sim/operation/prefs/startup_running")
battery_on = find_dataref("sim/cockpit2/electrical/battery_on[0]")
generator_on = find_dataref("sim/cockpit2/electrical/generator_on[0]")
avionics_power_on = find_dataref("sim/cockpit2/switches/avionics_power_on")
prop_pitch_cde = find_dataref("sim/cockpit2/switches/custom_slider_on[7]")
gear_lights = find_dataref("sim/cockpit2/switches/custom_slider_on[6]")
Instr_lighting = find_dataref("sim/cockpit2/switches/panel_brightness_ratio[0]")
Suction_Turn = find_dataref("sim/cockpit2/switches/custom_slider_on[11]")
Suction_Horizon = find_dataref("sim/cockpit2/switches/custom_slider_on[12]")
Suction_Gyro = find_dataref("sim/cockpit2/switches/custom_slider_on[13]")

----FUEL----
mixt_selector = find_dataref("sim/cockpit2/engine/actuators/mixture_ratio_all","number") --(0 for cutoff, 1 max)
mixt_override = find_dataref("sim/operation/override/override_mixture")
mixt_cutoff = create_dataref("custom/N1101/mixt_cutoff_selector","number") -- (0=none,1=mixture cutoff)
fuel_pump_fuse = find_dataref("sim/cockpit2/switches/custom_slider_on[8]")
fuel_pump_sw = find_dataref("sim/cockpit2/switches/custom_slider_on[23]")
fuel_pump_run = find_dataref("sim/cockpit/engine/fuel_pump_on[0]")

----AIR START---
air_compressor = create_dataref("custom/N1101/air_compressor","number")
air_recharge = create_dataref("custom/N1101/air_recharge","number")
air_isolation = create_dataref("custom/N1101/air_isolation","number")
air_needle = create_dataref("custom/N1101/air_needle","number")
start_lever = create_dataref("custom/N1101/start_lever","number")
engine_rpm = find_dataref("sim/cockpit2/engine/indicators/engine_speed_rpm[0]","number")
refill_sound = create_dataref("custom/N1101/refill_sound","number")

----VOLTMETER---
volt_needle = create_dataref("custom/N1101/volt_needle","number")
batt_gen_sw = find_dataref("sim/cockpit2/switches/custom_slider_on[4]","number")
batt_fuse = find_dataref("sim/cockpit/electrical/battery_on","number")
gen_fuse = find_dataref("sim/cockpit2/electrical/generator_on[0]","number")
batt_volts = find_dataref("sim/cockpit2/electrical/battery_voltage_indicated_volts[0]","number")
gen_volts = find_dataref("sim/cockpit2/electrical/bus_volts[0]","number")

----Chocks---
gr_speed = find_dataref("sim/flightmodel/position/groundspeed","number")
gear_dep = find_dataref("sim/aircraft/parts/acf_gear_deploy[1]","number")
park_brake = find_dataref("sim/cockpit2/controls/parking_brake_ratio","number")
on_ground = find_dataref("sim/flightmodel/failures/onground_all")
chocks_vis = create_dataref("custom/N1101/chocks_vis","number")
eng_on = find_dataref("sim/flightmodel/engine/ENGN_running[0]","number")
--------------------------------- DO THIS EACH FLIGHT START ---------------------------------
-----PREPARATION SI COLD AND DARK-------
function flight_start()

  air_needle = 30
  
	if startup_running == 1 then
		battery_on = 1
		generator_on = 1
		avionics_power_on = 1
		prop_pitch_cde = 1
		gear_lights = 1
		Instr_lighting = 1
		Suction_Turn = 1
		Suction_Horizon = 1
		Suction_Gyro = 1
	else
		battery_on = 0
		generator_on = 0
		avionics_power_on = 0
		prop_pitch_cde = 0
		gear_lights = 0
		Instr_lighting = 0
		Suction_Turn = 0
		Suction_Horizon = 0
		Suction_Gyro = 0
	end

end

------------------------------- FUNCTIONS: COMMANDS CALLBACK -------------------------------

-----CDE MANETTE ETOUFFOIR--------------
function cmd_mixt_cutoff(phase, duration)
	if phase == 1 then
      mixt_override = 1
			mixt_cutoff = 1
      mixt_selector = 0
  end
	if phase == 2 then
      mixt_override = 0
			mixt_cutoff = 0
      mixt_selector = mixt_selector
	end	
end

----DEMARREUR A AIR---------------------------

function cmd_air_compressor_on(phase, duration)
	if phase == 1 then
			air_compressor = 1
  end
end

function cmd_air_compressor_off(phase, duration)
	if phase == 0 then 
		air_compressor = 0
  end
end

function cmd_air_recharge_on(phase, duration)
	if phase == 1 then 
	  air_recharge = 1
  end
end

function cmd_air_recharge_off(phase, duration)
	if phase == 0 then 
	  air_recharge = 0
  end
end

function cmd_air_isolation_on(phase, duration)
	if phase == 1 then 
		air_isolation = 1
  end
end
function cmd_air_isolation_off(phase, duration)
	if phase == 0 then 
		air_isolation = 0
  end
end

function cmd_start_lever(phase, duration)
	if phase == 1 then 
    start_lever = 1
  else
    start_lever = 0
  end
end


-------------RUNTIME--------------

function update_volt_needle()
	 batt_volts = batt_volts + ((batt_voltsNEW - batt_volts) * (10 * SIM_PERIOD))
	 gen_volts = gen_volts + ((gen_voltsNEW - gen_volts) * (10 * SIM_PERIOD))
end

function after_physics()

    ---AIR BOTTLE REFILL---
    if air_compressor == 1 and air_needle < 30 and air_recharge == 0 and air_isolation == 0 and engine_rpm > 300 then
           air_needle = air_needle + 0.005
           refill_sound = 1
    else refill_sound = 0   
    end
    
    if air_recharge == 1 and air_needle < 30 and air_compressor == 0 and air_isolation == 0 and engine_rpm < 300 then
           air_needle = air_needle + 0.05
           refill_sound = 1
    else refill_sound = 0
    end     



    ---AIR STARTER ---
    if batt_fuse == 1 and air_isolation == 1 and air_compressor == 0 and air_recharge == 0 and start_lever == 1 then
       if air_needle > 12 then
          cmdenginestart:start()
          air_needle = air_needle - 0.05
       end
    elseif start_lever == 0 then
          cmdenginestart:stop()
    end


    ---FUEL PUMP---
    if fuel_pump_fuse == 0 then
		   fuel_pump_run = 0
		elseif fuel_pump_fuse == 1 and fuel_pump_sw == 0 then
       fuel_pump_run = 0
    else
       fuel_pump_run = 1
    end
    
    ---CHOCKS---
   	if on_ground == 1 and gr_speed < 0.5 and gear_dep == 1 and park_brake == 1 and eng_on == 0 then
              chocks_vis = 1
    else    
              chocks_vis = 0
    end 
    
    ---VOLTMETER---    
   batt_voltsNEW = batt_volts
   gen_voltsNEW = gen_volts
       if batt_fuse == 1 and batt_gen_sw == 0 then
          volt_needle = batt_volts
       elseif gen_fuse == 1 and batt_gen_sw == 1 then
          volt_needle = gen_volts
       else
          volt_needle = 0 
       end  
   update_volt_needle()
 
end


------------------------------- LOCATE AND/OR CREATE COMMANDS -------------------------------

---COMMANDE ETOUFFOIR--------------
cmdmixtcutoff = create_command("custom/N1101/mixture_cutoff","Mixture cutoff",cmd_mixt_cutoff)

----AIR START----------------------
cmdaircompressoron = create_command("custom/N1101/air_compressor_on","Air Compressor On",cmd_air_compressor_on)
cmdaircompressoroff = create_command("custom/N1101/air_compressor_off","Air Compressor Off",cmd_air_compressor_off)

cmdairrechargeon = create_command("custom/N1101/air_recharge_on","Air Recharge On",cmd_air_recharge_on)
cmdairrechargeoff = create_command("custom/N1101/air_recharge_off","Air Recharge Off",cmd_air_recharge_off)

cmdairisolationon = create_command("custom/N1101/air_isolation_on","Air Isolation On",cmd_air_isolation_on)
cmdairisolationoff = create_command("custom/N1101/air_isolation_off","Air Isolation Off",cmd_air_isolation_off)

cmdtartlever = create_command("custom/N1101/engine_start", "Engine start lever",cmd_start_lever)
cmdenginestart = find_command("sim/starters/engage_starter_1")




